/** 
* @file GSCluster.h
* @brief Generate Signature by Clustering Local Features (image-specific codebook!). The class can be used for the EMD kernel, but not for usual BoV approaches.
* @author Erik Rodner
* @date 10/30/2007

*/
#ifndef GSCLUSTERINCLUDE
#define GSCLUSTERINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"
  
#include "GenerateSignature.h"
#include "ClusterAlgorithm.h"


namespace OBJREC {

/** Generate Signature by Clustering Local Features */
class GSCluster : public GenerateSignature
{

    protected:
	int c_no_clusters;

	ClusterAlgorithm *clualg;

    public:
  
	/** simple constructor */
	GSCluster( const NICE::Config *conf );
      
	/** simple destructor */
	virtual ~GSCluster();
     
	void signature ( const NICE::VVector & features,
			 NICE::Vector & signature );
};


} // namespace

#endif
